﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title></title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:ScriptManager ID="ScriptManager1" runat="server">
		</asp:ScriptManager>
		<script type="text/javascript">
			function OnClientCommand(dock, args) {
				SaveState(dock, args);
			}

			function PositionChanged(sender, args) {
				SaveState(sender, args);
			}

			function SaveState(dock, args) {
				var i;
				var saveState = "";

				var AllDocks = get_allRadDocks(); // the docks on the page are referenced

				for (i = 0; i < AllDocks.length; i++) {
					var dock = AllDocks[i];
					saveState += GetSaveState(dock) + "|"; // for every RadDock the save state is appended in the saveState variable
				}
				
				var panel = $find("<%=RadXmlHttpPanel1.ClientID %>");
				panel.set_value(saveState); // the save state is passed to the RadXmlHttpPanel
			}

			function get_allRadDocks() { // custom method for getting the RadDocks on the page
				var allRadDocks = [];
				var allRadControls = $telerik.radControls;

				for (var i = 0; i < allRadControls.length; i++) {
					var element = allRadControls[i];

					if (Telerik.Web.UI.RadDock && element instanceof Telerik.Web.UI.RadDock) {
						Array.add(allRadDocks, element);
					}
				}
				return allRadDocks;
			}

			function GetSaveState(dock) { // custom method for collecting the save state
				var state =
				{
					UniqueName: dock.get_uniqueName(),
					DockZoneID: dock.get_dockZoneID(),
					Width: (dock.get_width() != null) ? dock.get_width() : "",
					Height: (dock.get_height() != null) ? dock.get_height() : "",
					ExpandedHeight: dock._expandedHeight,
					Top: dock.get_top(),
					Left: dock.get_left(),
					Resizable: dock.get_resizable().toString(),
					Closed: dock.get_closed().toString(),
					Collapsed: dock.get_collapsed().toString(),
					Pinned: dock.get_pinned().toString(),
					Title: dock.get_title(),
					Index: dock.get_index()
				};

				return Sys.Serialization.JavaScriptSerializer.serialize(state);
			}

			

		</script>
		<telerik:RadDockLayout runat="server" ID="RadDockLayout1" OnLoadDockLayout="RadDockLayout1_LoadDockLayout"
			OnSaveDockLayout="RadDockLayout1_SaveDockLayout">
			<telerik:RadDockZone runat="server" ID="RadDockZone1" Width="300" MinHeight="200"
				Style="float: left; margin-right: 20px;">
				<telerik:RadDock ID="RadDock1" UniqueName="RadDock1" runat="server" Width="300px" Title="Dock1" OnClientDockPositionChanged="PositionChanged" OnClientCommand="OnClientCommand">
				</telerik:RadDock>
				<telerik:RadDock ID="RadDock2"  UniqueName="RadDock2" runat="server" Width="300px" Title="Dock2" OnClientDockPositionChanged="PositionChanged" OnClientCommand="OnClientCommand">
				</telerik:RadDock>
				<telerik:RadDock ID="RadDock3"  UniqueName="RadDock3" runat="server" Width="300px" Title="Dock3" OnClientDockPositionChanged="PositionChanged" OnClientCommand="OnClientCommand">
				</telerik:RadDock>
			</telerik:RadDockZone>
		</telerik:RadDockLayout>
		<asp:Button ID="Button1" Text="Postback" runat="server" />
		<telerik:RadXmlHttpPanel runat="server" ID="RadXmlHttpPanel1" EnableClientScriptEvaluation="true"
			OnServiceRequest="RadXmlHttpPanel1_ServiceRequest">
		</telerik:RadXmlHttpPanel>
	</div>
	</form>
</body>
</html>
